!
!    Copyright 2014, 2015, 2017, 2018, 2020, 2021 Guy Munhoven
!
!    This file is part of µXML.
!
!    µXML is free software: you can redistribute it and/or modify
!    it under the terms of the GNU Affero General Public License as
!    published by the Free Software Foundation, either version 3 of
!    the License, or (at your option) any later version.
!
!    µXML is distributed in the hope that it will be useful, but
!    WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!    See the GNU Affero General Public License for more details.
!
!    You should have received a copy of the Affero GNU General Public
!    License along with µXML.  If not, see <https://www.gnu.org/licenses/>.
!


PROGRAM XMLCOCOGEN_MAIN

USE MOD_XMLCOCOGEN

IMPLICIT NONE

! Local variables
! ---------------

CHARACTER(LEN=p_maxlen_filename) :: c_xmlbaselist

TYPE(xfs_list), POINTER :: xml_compofiles
TYPE(xfs_list), POINTER :: xml_procsfiles
TYPE(xfs_list), POINTER :: xml_equilfiles


INTERFACE
  SUBROUTINE XMLCOCOGEN_LOADDB(c_xmlbaselist,      &
    xml_compofiles, xml_procsfiles, xml_equilfiles)
    USE MOD_XMLCOCOGEN
    CHARACTER(LEN=*) :: c_xmlbaselist
    TYPE(xfs_list), POINTER :: xml_compofiles
    TYPE(xfs_list), POINTER :: xml_procsfiles
    TYPE(xfs_list), POINTER :: xml_equilfiles
  END SUBROUTINE XMLCOCOGEN_LOADDB
END INTERFACE


c_xmlbaselist = 'list_medmbm.xml'
NULLIFY(xml_compofiles)
NULLIFY(xml_procsfiles)
NULLIFY(xml_equilfiles)

CALL XMLCOCOGEN_LOADDB(c_xmlbaselist, xml_compofiles, xml_procsfiles, xml_equilfiles)



END PROGRAM XMLCOCOGEN_MAIN
